// Message handler for ScriptingEnvironment
// by RagnarDarude
// christoffer.warnbring@gmail.com
// Oct 23 2009

call compile preprocessfile "armalib\alibinterface.sqf";
  
MHPIPENAME = "ASEpipe"; // Name of pipe used
MHREADY = false;
MHEND = false;
NNStimulis = [];
NNResponses = [];
NNEvaluates = [];
NNPropCount = 0;
AEWatchVars = [];
AENewWatchVars = [];
AERemoveWatchVars = [];

fn_EPAddWatch =
{
	private ["_var", "_return"];
	_var = _this;
	_return = false;
	if (count AEWatchVars == 0) then 
	{
		AEWatchVars = AEWatchVars + [_var];
		AENewWatchVars = AENewWatchVars + [_var]; 
		[] spawn fn_VarWatch;
		_return = true;
	}
	else 
	{
		if (!(_var in AEWatchVars)) then {AEWatchVars = AEWatchVars + [_var]; AENewWatchVars = AENewWatchVars + [_var]; _return = true;};
	};
	//player sideChat format["Number of varwatches: %1", count AEWatchVars];
	_return;
};
fn_EPRemoveWatch =
{
	private ["_var"];
	_var = _this;
	if (_var in AEWatchVars) then {
		AEWatchVars = AEWatchVars - [_var];
		AERemoveWatchVars = AERemoveWatchVars + [_var];
		};
	//player sideChat format["Watches now: %1", AEWatchVars];
};

fn_Log =
{
	_level = _this select 0;
	_message = _this select 1;
	["LOG", _level, _message] call fn_EPOut;
};

fn_LogDebug =
{
	["LOG", "DEBUG", _this] call fn_EPOut;
};

fn_LogInfo =
{
	["LOG", "INFO", _this] call fn_EPOut;
};

fn_LogWarn =
{
	["LOG", "WARN", _this] call fn_EPOut;
};

fn_LogError =
{
	["LOG", "ERROR", _this] call fn_EPOut;
};

fn_LogFatal =
{
	["LOG", "FATAL", _this] call fn_EPOut;
};


// Invokes a ScriptEvent in the ScriptModule
fn_InvokeScriptEvent = 
{
	private ["_event", "_parameter"];
	_event = _this select 0;
	_parameter = _this select 1;
	["EVENT", _event, _parameter] call fn_EPOut;
};

fn_VarWatch =
{
	private ["_u", "_WatchCopies", "_var"];
	sleep 2;

	_WatchCopies = [];
	_newvar = "";
	while {(count AEWatchVars) > 0} do
	{
		if (count AENewWatchVars != 0) then {
				{
					_newvar = call compile _x;
					_WatchCopies = _WatchCopies + [_newvar];
				} forEach AENewWatchVars;
				AENewWatchVars = [];
			};
			if (count AERemoveWatchVars != 0) then {
				{
					_removevar = call compile _x;
					_WatchCopies = _WatchCopies - [_removevar];
				} forEach AERemoveWatchVars;
				AERemoveWatchVars = [];
			};
		for "_u" from 0 to ( (count AEWatchVars)- 1) do
		{
			
			
			_var = call compile (AEWatchVars select _u);

			_oldvar = (_WatchCopies select _u);
			if (_var != _oldvar) then
			{
				["VAR CHANGED", (AEWatchVars select _u), _oldvar, _var] call fn_EPOut;
				if (count _WatchCopies != count AEWatchVars) then {_WatchCopies resize count AEWatchVars;};
				_WatchCopies set [_u, _var];
			};
		};

		sleep 1;
	};

};

fn_EPOut = {
  _msg = str (_this);

  //player groupchat "Writing: <" + _msg + ">";
	try {
  		"sl_WriteData" extCall [MHPIPENAME, _msg];
	 } catch {
	  	 player globalchat "Exception occured while writing to pipe: " + _exception;
	 };
};

fn_EPRefObj =                                                                                                                                          
{
	private ["_var", "_newname", "_x"];
	_var = _this;
	switch (typeName _var) do
	{
	
		case "OBJECT":
		{
	
		
			if ( vehicleVarName _var == "") then
			{
				_newname = format["ObjRef%1",  round (random 10000)];
							
				_var setVehicleVarName _newname;
				_var Call Compile Format ["%1=_This ; PublicVariable ""%1""",_newname];

											
			};
		}; 
		
		case "GROUP":
		{
									
			if ( typeName (str _var) != "GROUP") then
			{
				_newname = format["GrpRef%1",  round (random 10000)];								
				leader _var Call Compile Format ["%1=group _This ; PublicVariable ""%1""; %1",_newname];
				_var = _newname;						
			};	
											
		};
		case "ARRAY":
		{
			private ["_i"];
			_i = 0;
			for [{_i=0},{_i<count _var},{_i=_i+1}] do 
			{
				_var set [_i, (_var select _i) call fn_EPRefObj];
			};
		};
	};
	_var;
};

try {
  // Init scriptlink, name of pipe is returned
  // _ret is same as MYPIPENAME, unless MYPIPENAME is too long
  _ret = MHPIPENAME call slInit;
  player sidechat "Scriptlink " + (str _ret) + " active";
	MHREADY = false;
	
  // Wait until client connects
	player sidechat "Waiting for client";
  waitUntil{_ret call slIsConnected};
  player sidechat "Client connected";

  // For as long as client is connected...
  while{_ret call slIsConnected} do {
    // ...loop receiving data...
    // slReadData Returns an array of strings read
    _data = _ret call slReadData;
    {
      // ...and print it
      //player groupchat "Received: <" + _x + ">";
		 _message = call compile _x;
		 _command = _message select 0;
		if (_command == "BEGIN") then
		 {
			 
			 ["READY", worldName, missionName, benchmark] call fn_EPOut;
			 MHREADY = true;
		};
		switch (_command) do 
		{
			case "BEGIN":
			{
			};
			case "CALL":
			{
				// ID of ExternalProcessInteraction object
				_guid1 = (_message select 1);
				
				// ID of InteractionExchange object
				_guid2 = (_message select 2);
				
				//player sideChat "Call GUID1 #" + _guid1 + " GUID2 #" +_guid2;
				
				
				["COMPILING", _guid1, _guid2] call fn_EPOut;
				_code = _message select 3;
				_compiled = (_message select 3);
				if (typeName _compiled != "CODE") then
				{
					// Compile failed
					["COMPILE FAILED", _guid1, _guid2] call fn_EPOut;
				
				} else {
					// Compile success
					["CALLING", _guid1, _guid2] call fn_EPOut;
					[_compiled, _guid1, _guid2] spawn {
						_compiled = _this select 0;
						_guid1 = _this select 1;
						_guid2 = _this select 2;
						_return = "INIT/NULL";
						_exceptionthrown = false;
						try
						{
							
							_return = call _compiled;
							
						} catch {
							_exceptionthrown = true;
							["ERROR THROWN", _guid1, _guid2, _exception] call fn_EPOut;
						};
						if (!_exceptionthrown) then 
							{
								_return = _return call fn_EPRefObj;
								["RETURN", _guid1, _guid2, _return] call fn_EPOut;
							};
					};
				};
			};
			case "ADDWATCH":
			{
				//player sideChat "ADDWATCH";
				_var = (_message select 1);
				_return = _var call fn_EPAddWatch;
				if (_return) then 
				{
					["ADDEDVARWATCHNEW", _var, call compile _var] call fn_EPOut;
				} else {
					["ADDEDVARWATCHOLD", _var, call compile _var] call fn_EPOut;
				};
			};
			
			case "REMOVEWATCH":
			{
				//player sideChat "REMOVEWATCH";
				_var = (_message select 1);
				_var call fn_EPRemoveWatch;
			};
			
			case "END":
			{
				player sideChat "END command sent.";
				MHEND = true;
			};
			default
			{
				player sideChat format["WARNING! Unknown command: %1", _command];
				format["Unknown command: %1", _command] call fn_LogWarn;
			};
		};
		if (MHEND) exitWith {};
    } foreach _data;
	
	if (MHEND) exitWith {};
    // If no data was read (emptry array returned), sleep a while
    if(count _data == 0) then {sleep 0.1};
  };

	MHREADY = false;
  // Disconnected
  player sidechat "Scriptlink " + (str _ret) + " disconnected";

} catch {
  // Exception - An error occured somewhere along the process
  player globalchat "Exception occured: " + _exception;
};


