// Header-file defining wether or not to use script logging 
// and ScriptEvents
//
// Usage:
//
// #include "ScriptLogging.h"
// startLog;
// logError("There was an error in the script!");
// ScriptEvent("MyEvent", damage player);
//
//
//
// *** by RagnarDarude ***
// christoffer.warnbring@gmail.com
// Oct 23 2009 
//
//

// Comment out the next line to not use logging in your mission
#define USESCRIPTLOGGING


// Comment out the next line to not use ScriptEvents in your mission
#define USESCRIPTEVENTS




#ifdef USESCRIPTLOGGING

// Start logging mechanism
#define startLog \
	[] execVM "MessageHandler.sqf"; \
	sleep 0.2;
	

// Log message (level, message)
#define log(x, y) \
	while {typeName MHREADY == ""} do {sleep 1;}; \
	while {!MHREADY} do {sleep 1;}; \
	[##x, y##] call fn_Log;



// Log Debug level message
#define logDebug(x) log("DEBUG", x)

// Log Info level message
#define logInfo(x) log("INFO", x)

// Log Warning level message
#define logWarn(x) log("WARN", x)

// Log Error level message
#define logError(x) log("ERROR", x)

// Log Fatal level message
#define logFatal(x) log("FATAL", x)

#else

// Dont use logging

#define startLog
#define log(x, y)
#define logDebug(x)
#define logInfo(x)
#define logWarn(x)
#define logError(x)
#define logFatal(x)

#endif // USESCRIPTLOGGING



#ifdef USESCRIPTEVENTS

// Start script event mechanism (same as logging)
#define startSE \
	if (!(typeName MHREADY == "BOOL")) then  \
	{[] execVM "MessageHandler.sqf"; sleep 0.2;} \
	else {if (!MHREADY) then {[] execVM "MessageHandler.sqf"; sleep 0.2;}};

// Fire a script event (Name of scriptevent, Parameters)
#define ScriptEvent(x, y) [##x, y##] call fn_InvokeScriptEvent

#else

#define StartSE
#define ScriptEvent(x, y)

#endif // USESCRIPTEVENTS
